Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -3572,18 +5712,27 @@
 
 						$tLabel = 'Update database tables and fields';
 
-						if ($remove_statements || $update_statements)	{
+						if ($remove_statements || $update_statements) {
 							$formContent = $this->generateUpdateDatabaseForm('get_form',$update_statements,$remove_statements,$action_type);
-							$this->message($tLabel,'Table and field definitions should be updated',"
-							There seems to be a number of differencies between the database and the selected SQL-file.
-							Please select which statements you want to execute in order to update your database:<br /><br />
-							".$formContent."
-							",2);
+							$this->message($tLabel, 'Table and field definitions should be updated', '
+								<p>
+									There seems to be a number of differencies
+									between the database and the selected
+									SQL-file.
+									<br />
+									Please select which statements you want to
+									execute in order to update your database:
+								</p>
+							' . $formContent, 2);
 						} else {
 							$formContent = $this->generateUpdateDatabaseForm('get_form',$update_statements,$remove_statements,$action_type);
-							$this->message($tLabel,'Table and field definitions are OK.',"
-							The tables and fields in the current database corresponds perfectly to the database in the selected SQL-file.
-							",-1);
+							$this->message($tLabel, 'Table and field definitions are OK.', '
+								<p>
+									The tables and fields in the current
+									database corresponds perfectly to the
+									database in the selected SQL-file.
+								</p>
+							', -1);
 						}
 					}
 				break;
@@ -3594,16 +5743,25 @@
 						// Displaying configured fields which are not in the database
 					$tLabel='Tables and fields in $TCA, but not in database';
 					$cmpTCA_DB = $this->compareTCAandDatabase($GLOBALS['TCA'],$FDdb);
-					if (!count($cmpTCA_DB['extra']))	{
-						$this->message($tLabel,'Table and field definitions OK','
-						All fields and tables configured in $TCA appeared to exist in the database as well
-						',-1);
+					if (!count($cmpTCA_DB['extra'])) {
+						$this->message($tLabel, 'Table and field definitions OK', '
+							<p>
+								All fields and tables configured in $TCA
+								appeared to exist in the database as well
+							</p>
+						', -1);
 					} else {
-						$this->message($tLabel,'Invalid table and field definitions in $TCA!','
-						There are some tables and/or fields configured in the $TCA array which do not exist in the database!
-						This will most likely cause you trouble with the TYPO3 backend interface!
-						',3);
-						while(list($tableName, $conf)=each($cmpTCA_DB['extra']))	{
+						$this->message($tLabel, 'Invalid table and field definitions in $TCA!', '
+							<p>
+								There are some tables and/or fields configured
+								in the $TCA array which do not exist in the
+								database!
+								<br />
+								This will most likely cause you trouble with the
+								TYPO3 backend interface!
+							</p>
+						', 3);
+						foreach ($cmpTCA_DB['extra'] as $tableName => $conf) {
 							$this->message($tLabel, $tableName,$this->displayFields($conf['fields'],0,'Suggested database field:'),2);
 						}
 					}
@@ -3611,7 +5769,7 @@
 						// Displaying tables that are not setup in
 					$cmpDB_TCA = $this->compareDatabaseAndTCA($FDdb,$GLOBALS['TCA']);
 					$excludeTables='be_sessions,fe_session_data,fe_sessions';
-					if (TYPO3_OS=='WIN')	{$excludeTables = strtolower($excludeTables);}
+					if (TYPO3_OS=='WIN') {$excludeTables = strtolower($excludeTables);}
 					$excludeFields = array(
 						'be_users' => 'uc,lastlogin,usergroup_cached_list',
 						'fe_users' => 'uc,lastlogin,fe_cruser_id',
@@ -3626,55 +5784,89 @@
 					$tLabel="Tables from database, but not in \$TCA";
 					$fLabel="Fields from database, but not in \$TCA";
 					$this->message($tLabel);
-					if (is_array($cmpDB_TCA['extra']))	{
-						while(list($tableName, $conf)=each($cmpDB_TCA['extra']))	{
+					if (is_array($cmpDB_TCA['extra'])) {
+						foreach ($cmpDB_TCA['extra'] as $tableName => $conf) {
 							if (!t3lib_div::inList($excludeTables,$tableName)
 									&& substr($tableName,0,4)!="sys_"
 									&& substr($tableName,-3)!="_mm"
 									&& substr($tableName,0,6)!="index_"
-									&& substr($tableName,0,6)!='cache_')	{
-								if ($conf['whole_table'])	{
+									&& substr($tableName,0,6)!='cache_') {
+								if ($conf['whole_table']) {
 									$this->message($tLabel, $tableName,$this->displayFields($conf['fields']),1);
 									$tCount++;
 								} else {
 									list($theContent, $fC)	= $this->displaySuggestions($conf['fields'],$excludeFields[$tableName]);
 									$fCount+=$fC;
-									if ($fC)	$this->message($fLabel, $tableName,$theContent,1);
+									if ($fC) {
+										$this->message($fLabel, $tableName,$theContent,1);
+									}
 								}
 							}
 						}
 					}
-					if (!$tCount)	{
-						$this->message($tLabel,'Correct number of tables in the database',"
-						There are no extra tables in the database compared to the configured tables in the \$TCA array.
-						",-1);
+					if (!$tCount) {
+						$this->message($tLabel, 'Correct number of tables in the database', '
+							<p>
+								There are no extra tables in the database
+								compared to the configured tables in the $TCA
+								array.
+							</p>
+						', -1);
 					} else {
-						$this->message($tLabel,'Extra tables in the database',"
-						There are some tables in the database which are not configured in the \$TCA array.
-						You should probably not worry about this, but please make sure that you know what these tables are about and why they are not configured in \$TCA.
-						",2);
+						$this->message($tLabel, 'Extra tables in the database', '
+							<p>
+								There are some tables in the database which are
+								not configured in the $TCA array.
+								<br />
+								You should probably not worry about this, but
+								please make sure that you know what these tables
+								are about and why they are not configured in
+								$TCA.
+							</p>
+						', 2);
 					}
 
-					if (!$fCount)	{
-						$this->message($fLabel,'Correct number of fields in the database',"
-						There are no additional fields in the database tables compared to the configured fields in the \$TCA array.
-						",-1);
+					if (!$fCount) {
+						$this->message($fLabel, 'Correct number of fields in the database', '
+							<p>
+								There are no additional fields in the database
+								tables compared to the configured fields in the
+								$TCA array.
+							</p>
+						', -1);
 					} else {
-						$this->message($fLabel,'Extra fields in the database',"
-						There are some additional fields the database tables which are not configured in the \$TCA array.
-						You should probably not worry about this, but please make sure that you know what these fields are about and why they are not configured in \$TCA.
-						",2);
+						$this->message($fLabel, 'Extra fields in the database', '
+							<p>
+								There are some additional fields the database
+								tables which are not configured in the $TCA
+								array.
+								<br />
+								You should probably not worry about this, but
+								please make sure that you know what these fields
+								are about and why they are not configured in
+								$TCA.
+							</p>
+						', 2);
 					}
 
 						// Displaying actual and suggested field database defitions
-					if (is_array($cmpTCA_DB['matching']))	{
+					if (is_array($cmpTCA_DB['matching'])) {
 						$tLabel="Comparison between database and \$TCA";
 
-						$this->message($tLabel,'Actual and suggested field definitions',"
-						This table shows you the suggested field definitions which are calculated based on the configuration in \$TCA.
-						If the suggested value differs from the actual current database value, you should not panic, but simply check if the datatype of that field is sufficient compared to the data, you want TYPO3 to put there.
-						",0);
-						while(list($tableName, $conf)=each($cmpTCA_DB['matching']))	{
+						$this->message($tLabel, 'Actual and suggested field definitions', '
+							<p>
+								This table shows you the suggested field
+								definitions which are calculated based on the
+								configuration in $TCA.
+								<br />
+								If the suggested value differs from the actual
+								current database value, you should not panic,
+								but simply check if the datatype of that field
+								is sufficient compared to the data, you want
+								TYPO3 to put there.
+							</p>
+						', 0);
+						foreach ($cmpTCA_DB['matching'] as $tableName => $conf) {
 							$this->message($tLabel, $tableName,$this->displayFieldComp($conf['fields'], $FDdb[$tableName]['fields']),1);
 						}
 					}
@@ -3682,44 +5874,44 @@
 				case 'import':
 					$mode123Imported=0;
 					$tblFileContent='';
-					if (preg_match('/^CURRENT_/', $actionParts[1]))	{
-						if (!strcmp($actionParts[1],'CURRENT_TABLES') || !strcmp($actionParts[1],'CURRENT_TABLES+STATIC'))	{
+					if (preg_match('/^CURRENT_/', $actionParts[1])) {
+						if (!strcmp($actionParts[1],'CURRENT_TABLES') || !strcmp($actionParts[1],'CURRENT_TABLES+STATIC')) {
 							$tblFileContent = t3lib_div::getUrl(PATH_t3lib.'stddb/tables.sql');
 
-							reset($GLOBALS['TYPO3_LOADED_EXT']);
-							while(list(,$loadedExtConf)=each($GLOBALS['TYPO3_LOADED_EXT']))	{
-								if (is_array($loadedExtConf) && $loadedExtConf['ext_tables.sql'])	{
+							foreach ($GLOBALS['TYPO3_LOADED_EXT'] as $loadedExtConf) {
+								if (is_array($loadedExtConf) && $loadedExtConf['ext_tables.sql']) {
 									$tblFileContent.= chr(10).chr(10).chr(10).chr(10).t3lib_div::getUrl($loadedExtConf['ext_tables.sql']);
 								}
 							}
 						}
-						if (!strcmp($actionParts[1],'CURRENT_STATIC') || !strcmp($actionParts[1],'CURRENT_TABLES+STATIC'))	{
-							reset($GLOBALS['TYPO3_LOADED_EXT']);
-							while(list(,$loadedExtConf)=each($GLOBALS['TYPO3_LOADED_EXT']))	{
-								if (is_array($loadedExtConf) && $loadedExtConf['ext_tables_static+adt.sql'])	{
+						if (!strcmp($actionParts[1],'CURRENT_STATIC') || !strcmp($actionParts[1],'CURRENT_TABLES+STATIC')) {
+							foreach ($GLOBALS['TYPO3_LOADED_EXT'] as $loadedExtConf) {
+								if (is_array($loadedExtConf) && $loadedExtConf['ext_tables_static+adt.sql']) {
 									$tblFileContent.= chr(10).chr(10).chr(10).chr(10).t3lib_div::getUrl($loadedExtConf['ext_tables_static+adt.sql']);
 								}
 							}
 						}
-					} elseif (@is_file($actionParts[1]))	{
+					} elseif (@is_file($actionParts[1])) {
 						$tblFileContent = t3lib_div::getUrl($actionParts[1]);
 					}
 
-					if ($tblFileContent)	{
+					if ($tblFileContent) {
 						$tLabel='Import SQL dump';
 							// Getting statement array from
 						$statements = $this->getStatementArray($tblFileContent,1);
 						list($statements_table, $insertCount) = $this->getCreateTables($statements,1);
 
 							// Updating database...
-						if ($this->INSTALL['database_import_all'])	{
+						if ($this->INSTALL['database_import_all']) {
 							$r=0;
-							foreach ($statements as $k=>$v)	{
+							foreach ($statements as $k=>$v) {
 								$res = $GLOBALS['TYPO3_DB']->admin_query($v);
 								$r++;
 							}
 
-								// Make a database comparison because some tables that are defined twice have not been created at this point. This applies to the "pages.*" fields defined in sysext/cms/ext_tables.sql for example.
+								// Make a database comparison because some tables that are defined twice have
+								// not been created at this point. This applies to the "pages.*"
+								// fields defined in sysext/cms/ext_tables.sql for example.
 							$fileContent = implode(
 								$this->getStatementArray($tblFileContent,1,'^CREATE TABLE '),
 								chr(10)
@@ -3728,13 +5920,13 @@
 							$FDdb = $this->getFieldDefinitions_database();
 							$diff = $this->getDatabaseExtra($FDfile, $FDdb);
 							$update_statements = $this->getUpdateSuggestions($diff);
-							if (is_array($update_statements['add']))	{
-								foreach ($update_statements['add'] as $statement)	{
+							if (is_array($update_statements['add'])) {
+								foreach ($update_statements['add'] as $statement) {
 									$res = $GLOBALS['TYPO3_DB']->admin_query($statement);
 								}
 							}
 
-							if ($this->mode=='123')	{
+							if ($this->mode=='123') {
 									// Create default be_user admin/password
 								$username = 'admin';
 								$pass = 'password';
@@ -3759,77 +5951,157 @@
 								}
 							}
 
-							$this->message($tLabel,'Imported ALL',"
-								Queries: ".$r."
-							",1,1);
-							if (t3lib_div::_GP('goto_step'))	{
+							$this->message($tLabel, 'Imported ALL', '
+								<p>
+									Queries: ' . $r . '
+								</p>
+							', 1, 1);
+							if (t3lib_div::_GP('goto_step')) {
 								$this->action.='&step='.t3lib_div::_GP('goto_step');
 								t3lib_utility_Http::redirect($this->action);
 							}
-						} elseif (is_array($this->INSTALL['database_import']))	{
+						} elseif (is_array($this->INSTALL['database_import'])) {
 								// Traverse the tables
-							reset($this->INSTALL['database_import']);
-							while(list($table,$md5str)=each($this->INSTALL['database_import']))	{
-								if ($md5str==md5($statements_table[$table]))	{
+							foreach ($this->INSTALL['database_import'] as $table => $md5str) {
+								if ($md5str==md5($statements_table[$table])) {
 									$res = $GLOBALS['TYPO3_DB']->admin_query('DROP TABLE IF EXISTS '.$table);
 									$res = $GLOBALS['TYPO3_DB']->admin_query($statements_table[$table]);
 
-									if ($insertCount[$table])	{
+									if ($insertCount[$table]) {
 										$statements_insert = $this->getTableInsertStatements($statements, $table);
-										reset($statements_insert);
-										while(list($k,$v)=each($statements_insert))	{
+										foreach ($statements_insert as $k => $v) {
 											$res = $GLOBALS['TYPO3_DB']->admin_query($v);
 										}
 									}
 
-									$this->message($tLabel,"Imported '".$table."'","
-										Rows: ".$insertCount[$table]."
-									",1,1);
+									$this->message($tLabel, 'Imported \'' . $table . '\'', '
+										<p>
+											Rows: ' . $insertCount[$table] . '
+										</p>
+									', 1, 1);
 								}
 							}
 						}
 
 						$mode123Imported=$this->isBasicComplete($tLabel);
 
-						if (!$mode123Imported)	{
+						if (!$mode123Imported) {
 								// Re-Getting current tables - may have been changed during import
 							$whichTables=$this->getListOfTables();
 
-							if (count($statements_table))	{
+							if (count($statements_table)) {
 								reset($statements_table);
 								$out='';
-								while(list($table,$definition)=each($statements_table))	{
-									$exist=isset($whichTables[$table]);
-									$out.='<tr>
-										<td><input type="checkbox" name="TYPO3_INSTALL[database_import]['.$table.']" id="database_import_'.$table.'" value="'.md5($definition).'"></td>
-										<td><label for="database_import_'.$table.'"><strong>'.$this->fw($table).'</strong></label></td>
-										<td><img src="clear.gif" width="10" height="1"></td>
-										<td nowrap="nowrap">'.$this->fw($insertCount[$table]?"Rows: ".$insertCount[$table]:"").'</td>
-										<td><img src="clear.gif" width="10" height="1"></td>
-										<td nowrap="nowrap">'.($exist?'<img src="'.$this->backPath.'gfx/icon_warning.gif" width="18" height="16" align="top" alt="">'.$this->fw('Table exists!'):'').'</td>
-										</tr>';
-								}
+									// Get the template file
+								$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckTheDatabaseImport.html');
+									// Get the template part from the file
+								$content = $this->contentObject->getSubpart($templateFile, '###IMPORT###');
 
-								$content ='';
-								if ($this->mode!='123')	{
-									$content.='<table border="0" cellpadding="0" cellspacing="0">'.$out.'</table>
-									<hr />
-									';
+								if ($this->mode!='123') {
+									$tables = array();
+										// Get the subpart for regular mode
+									$regularModeSubpart = $this->contentObject->getSubpart($content, '###REGULARMODE###');
+									foreach ($statements_table as $table => $definition) {
+											// Get the subpart for rows
+										$tableSubpart = $this->contentObject->getSubpart($content, '###ROWS###');
+											// Fill the 'table exists' part when it exists
+										$exist=isset($whichTables[$table]);
+										if ($exist) {
+												// Get the subpart for table exists
+											$existSubpart = $this->contentObject->getSubpart($tableSubpart, '###EXIST###');
+												// Define the markers content
+											$existMarkers = array (
+												'tableExists' => 'Table exists!',
+												'backPath' => $this->backPath
+											);
+												// Fill the markers in the subpart
+											$existSubpart = $this->contentObject->substituteMarkerArray(
+												$existSubpart,
+												$existMarkers,
+												'###|###',
+												1,
+												1
+											);
+										}
+											// Substitute the subpart for table exists
+										$tableHtml = $this->contentObject->substituteSubpart(
+											$tableSubpart,
+											'###EXIST###',
+											$existSubpart
+										);
+											// Define the markers content
+										$tableMarkers = array (
+											'table' => $table,
+											'definition' => md5($definition),
+											'count' => $insertCount[$table] ? $insertCount[$table] : '',
+											'rowLabel' => $insertCount[$table] ? 'Rows: ' : '',
+											'tableExists' => 'Table exists!',
+											'backPath' => $this->backPath
+										);
+											// Fill the markers
+										$tables[] = $this->contentObject->substituteMarkerArray(
+											$tableHtml,
+											$tableMarkers,
+											'###|###',
+											1,
+											1
+										);
+									}
+										// Substitute the subpart for the rows
+									$regularModeSubpart = $this->contentObject->substituteSubpart(
+										$regularModeSubpart,
+										'###ROWS###',
+										implode(chr(10), $tables)
+									);
 								}
-								$content.='<input type="checkbox" name="TYPO3_INSTALL[database_import_all]" id="database_import_all" value="1"'.($this->mode=="123"||t3lib_div::_GP('presetWholeTable')?' checked="checked"':'').'> <label for="database_import_all">'.$this->fw("Import the whole file '".basename($actionParts[1])."' directly (ignores selections above)").'</label><br />
+									// Substitute the subpart for the regular mode
+								$content = $this->contentObject->substituteSubpart(
+									$content,
+									'###REGULARMODE###',
+									$regularModeSubpart
+								);
+									// Define the markers content
+								$contentMarkers = array(
+									'checked' => ($this->mode == '123' || t3lib_div::_GP('presetWholeTable') ? 'checked="checked"' : ''),
+									'label' => 'Import the whole file \'' . basename($actionParts[1]) . '\' directly (ignores selections above)'
+								);
+									// Fill the markers
+								$content = $this->contentObject->substituteMarkerArray(
+									$content,
+									$contentMarkers,
+									'###|###',
+									1,
+									1
+								);
 
-								';
 								$form = $this->getUpdateDbFormWrap($action_type, $content);
-								$this->message($tLabel,'Select tables to import',"
-								This is an overview of the CREATE TABLE definitions in the SQL file.
-								Select which tables you want to dump to the database.
-								Any table you choose dump to the database is dropped from the database first, so you'll lose all data in existing tables.
-								".$form,1,1);
+								$this->message($tLabel, 'Select tables to import', '
+									<p>
+										This is an overview of the CREATE TABLE
+										definitions in the SQL file.
+										<br />
+										Select which tables you want to dump to
+										the database.
+										<br />
+										Any table you choose dump to the
+										database is dropped from the database
+										first, so you\'ll lose all data in
+										existing tables.
+									</p>
+								' . $form, 1, 1);
 							} else {
-								$this->message($tLabel,'No tables',"
-								There seems to be no CREATE TABLE definitions in the SQL file.
-								This tool is intelligently creating one table at a time and not just dumping the whole content of the file uncritically. That's why there must be defined tables in the SQL file.
-								",3,1);
+								$this->message($tLabel, 'No tables', '
+									<p>
+										There seems to be no CREATE TABLE
+										definitions in the SQL file.
+										<br />
+										This tool is intelligently creating one
+										table at a time and not just dumping the
+										whole content of the file uncritically.
+										That\'s why there must be defined tables
+										in the SQL file.
+									</p>
+								', 3, 1);
 							}
 						}
 					}
@@ -3843,101 +6115,178 @@
 						$maxL = 1000;
 						$strLen = strlen($fileContent);
 						$maxlen = 200+($maxL-t3lib_div::intInRange(($strLen-20000)/100,0,$maxL));
-						if (count($statements))	{
+						if (count($statements)) {
 							$out = '';
 							foreach ($statements as $statement) {
-								$out.= nl2br(htmlspecialchars(t3lib_div::fixed_lgd_cs($statement,$maxlen)).chr(10).chr(10));
+								$out.= '<p>' . nl2br(htmlspecialchars(t3lib_div::fixed_lgd_cs($statement,$maxlen))) . '</p>';
 							}
 						}
 						$this->message($tLabel,'Content of '.basename($actionParts[1]),$out,1);
 					}
 				break;
-				case 'adminUser':	// Create admin user
-					if ($whichTables['be_users'])	{
-						if (is_array($this->INSTALL['database_adminUser']))	{
+					// Create admin user
+				case 'adminUser':
+					if ($whichTables['be_users']) {
+						if (is_array($this->INSTALL['database_adminUser'])) {
 							$username = preg_replace('/[^\da-z._-]/i', '', trim($this->INSTALL['database_adminUser']['username']));
 							$pass = trim($this->INSTALL['database_adminUser']['password']);
 							$pass2 = trim($this->INSTALL['database_adminUser']['password2']);
-							if ($username && $pass && $pass2)	{
+							if ($username && $pass && $pass2) {
 								if ($pass != $pass2) {
 									$this->message($headCode, 'Passwords are not equal!', '
-										The passwords entered twice are not equal.',2,1);
+										<p>
+											The passwords entered twice are not
+											equal.
+										</p>
+									', 2, 1);
 								} else {
-								$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', 'be_users', 'username='.$GLOBALS['TYPO3_DB']->fullQuoteStr($username, 'be_users'));
-								if (!$GLOBALS['TYPO3_DB']->sql_num_rows($res))	{
+									$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', 'be_users', 'username='.$GLOBALS['TYPO3_DB']->fullQuoteStr($username, 'be_users'));
+									if (!$GLOBALS['TYPO3_DB']->sql_num_rows($res)) {
 
-									$insertFields = array(
-										'username' => $username,
-										'password' => md5($pass),
-										'admin' => 1,
-										'uc' => '',
-										'fileoper_perms' => 0,
-										'tstamp' => $GLOBALS['EXEC_TIME'],
-										'crdate' => $GLOBALS['EXEC_TIME']
-									);
+										$insertFields = array(
+											'username' => $username,
+											'password' => md5($pass),
+											'admin' => 1,
+											'uc' => '',
+											'fileoper_perms' => 0,
+											'tstamp' => $GLOBALS['EXEC_TIME'],
+											'crdate' => $GLOBALS['EXEC_TIME']
+										);
 
-									$result = $GLOBALS['TYPO3_DB']->exec_INSERTquery('be_users', $insertFields);
+										$result = $GLOBALS['TYPO3_DB']->exec_INSERTquery('be_users', $insertFields);
 
-									$this->isBasicComplete($headCode);
+										$this->isBasicComplete($headCode);
 
-									if ($result) {
-										$this->message($headCode,'User created','
-												Username: <strong>'.htmlspecialchars($username).'</strong><br />',
-											1,1);
+										if ($result) {
+											$this->message($headCode, 'User created', '
+												<p>
+													Username:
+													<strong>' .
+														htmlspecialchars($username) . '
+													</strong>
+												</p>
+											', 1, 1);
+										} else {
+											$this->message($headCode, 'User not created', '
+												<p>
+													Error:
+													<strong>' .
+														htmlspecialchars($GLOBALS['TYPO3_DB']->sql_error()) . '
+													</strong>
+												</p>
+											', 3, 1);
+										}
 									} else {
-										$this->message($headCode,'User not created','
-											Error: <strong>'.htmlspecialchars($GLOBALS['TYPO3_DB']->sql_error()).'</strong><br />',
-											3,1);
+										$this->message($headCode, 'Username not unique!', '
+											<p>
+												The username,
+												<strong>' .
+													htmlspecialchars($username) . '
+												</strong>
+												, was not unique.
+											</p>
+										', 2, 1);
 									}
-								} else {
-									$this->message($headCode,'Username not unique!','
-									The username, <strong>'.htmlspecialchars($username).'</strong>, was not unique.',2,1);
 								}
+							} else {
+								$this->message($headCode, 'Missing data!', '
+									<p>
+										Not all required form fields have been
+										filled.
+									</p>
+								', 2, 1);
 							}
-						} else {
-							$this->message($headCode,'Missing data!','
-								Not all required form fields have been filled.',2,1);
 						}
-						}
-						$content = '
-						<input type="text" name="TYPO3_INSTALL[database_adminUser][username]"> username - unique, no space, lowercase<br />
-						<input type="password" name="TYPO3_INSTALL[database_adminUser][password]"> password
-						<input type="password" name="TYPO3_INSTALL[database_adminUser][password2]"> password (repeated)
-						';
+							// Get the template file
+						$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckTheDatabaseAdminUser.html');
+							// Get the template part from the file
+						$content = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+							// Define the markers content
+						$contentMarkers = array(
+							'userName' => 'username - unique, no space, lowercase',
+							'password' => 'password',
+							'repeatPassword' => 'password (repeated)'
+						);
+							// Fill the markers
+						$content = $this->contentObject->substituteMarkerArray(
+							$content,
+							$contentMarkers,
+							'###|###',
+							1,
+							1
+						);
 						$form = $this->getUpdateDbFormWrap($action_type, $content);
-						$this->message($headCode,'Create admin user',"
-						Enter username and password for a new admin user.<br />
-						You should use this function only if there are no admin users in the database, for instance if this is a blank database.<br />
-						After you've created the user, log in and add the rest of the user information, like email and real name.<br />
-						<br />
-						".$form."
-						",0,1);
+						$this->message($headCode, 'Create admin user', '
+							<p>
+								Enter username and password for a new admin
+								user.
+								<br />
+								You should use this function only if there are
+								no admin users in the database, for instance if
+								this is a blank database.
+								<br />
+								After you\'ve created the user, log in and add
+								the rest of the user information, like email and
+								real name.
+							</p>
+						' . $form, 0, 1);
 					} else {
-						$this->message($headCode,'Required table not in database',"
-						'be_users' must be a table in the database!
-						",3,1);
+						$this->message($headCode, 'Required table not in database', '
+							<p>
+								\'be_users\' must be a table in the database!
+							</p>
+						', 3, 1);
 					}
 				break;
-				case 'UC':	// clear uc
-					if ($whichTables['be_users'])	{
-						if (!strcmp($this->INSTALL['database_UC'],1))	{
+					// clear uc
+				case 'UC':
+					if ($whichTables['be_users']) {
+						if (!strcmp($this->INSTALL['database_UC'],1)) {
 							$GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_users', '', array('uc' => ''));
-							$this->message($headCode,'Clearing be_users.uc','Done.',1);
+							$this->message($headCode, 'Clearing be_users.uc', '
+								<p>
+									Done.
+								</p>
+							', 1);
 						}
-						$content = '
-						<input type="checkbox" name="TYPO3_INSTALL[database_UC]" id="database_UC" value="1" checked="checked"> <label for="database_UC">Clear be_users preferences ("uc" field)</label>
-						';
+							// Get the template file
+						$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckTheDatabaseUc.html');
+							// Get the template part from the file
+						$content = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+							// Define the markers content
+						$contentMarkers = array(
+							'clearBeUsers' => 'Clear be_users preferences ("uc" field)'
+						);
+							// Fill the markers
+						$content = $this->contentObject->substituteMarkerArray(
+							$content,
+							$contentMarkers,
+							'###|###',
+							1,
+							1
+						);
+
 						$form = $this->getUpdateDbFormWrap($action_type, $content);
-						$this->message($headCode,'Clear user preferences',"
-						If you press this button all backend users from the tables be_users will have their user preferences cleared (field 'uc' set to an empty string).<br />
-						This may come in handy in rare cases where that configuration may be corrupt.<br />
-						Clearing this will clear all user settings from the 'Setup' module.<br />
-						<br />
-						".$form);
+						$this->message($headCode, 'Clear user preferences', '
+							<p>
+								If you press this button all backend users from
+								the tables be_users will have their user
+								preferences cleared (field \'uc\' set to an
+								empty string).
+								<br />
+								This may come in handy in rare cases where that
+								configuration may be corrupt.
+								<br />
+								Clearing this will clear all user settings from
+								the \'Setup\' module.
+							</p>
+						' . $form);
 					} else {
-						$this->message($headCode,'Required table not in database',"
-						'be_users' must be a table in the database!
-						",3);
+						$this->message($headCode, 'Required table not in database', '
+							<p>
+								\'be_users\' must be a table in the database!
+							</p>
+						', 3);
 					}
 				break;
 				case 'cache':
